from pieces import allpieces

from check_beta import checkbeta
from checking_routines import (checkprecision,
                               checkterminals, checksymmetry)
from output_routines import text_print_piece_coordinates
import solve_all_patterns

print "Program run_all_pieces.py. Checking all pieces"    
tablefile = open("results/MWT-tables.tex","w")
tablefile.write(r"""
  \offinterlineskip
  \halign{\vrule \strut\hfil\ #\hfil \vrule &\ \hfil $#$ \hfil\vrule
     &&\ \hfil $#$ \hfil\vrule \cr
   \noalign{\hrule}
   \raise2pt\hbox{\strut}pattern & $multiplicity$ &$internal cost $c 
    & $reduced internal cost $\bar c
    & $relative reduced cost $\tilde c\cr""")
shorttablefile = open("results/MWT-short-table.tex","w")
shorttablefile.write(r"""
\vbox{\hbox
 {\valign{\hrule\hbox{\vrule\ \raise1pt\hbox{\strut}\strut # }\hrule
     &\hbox {\vrule\ \raise2pt\hbox{\strut}\strut\ # }%
     &&\hbox {\vrule\ \strut\ # }\cr
     & LL& LR& RL& RR\cr
""")

coordinatefile = open("results/all_pieces_coordinates.txt","w")

minbeta = 999

for piece in allpieces:
    print "========================",piece["name"],20*"="
    text_print_piece_coordinates(piece,coordinatefile)
    checkprecision(piece) # at most 4 digits after the decimal point
    checkterminals(piece)
    checksymmetry(piece)
    beta = checkbeta(piece)
    minbeta = min(minbeta,beta)

    solve_all_patterns.solve_all_patterns(piece,
      tablefile, picturefile=True, condensed_tablefile=shorttablefile)

print "\nminimum beta (overall) =", minbeta

tablefile.write("\n}\n")
tablefile.close()
shorttablefile.write(r"}\vrule}\hrule}"+"\n")
shorttablefile.close()
coordinatefile.close()
